EDIT - bug #9185

DateHeaderFilter.doFilter(..) causes NPE in FrameworkServlet.processRequest(..) on 404 HTTP
response

08/12/2020 07:17 AM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmlib-remote Estimated time: 0:00 hour
Target version: Release 5.23

Severity: normal Found in Version:

Description

00:00:05.479 [flora-malesiana] [gtp527446182-27609] INFO e.e.c.r.controller.BaseController - doGe
tMethod () [doGetAnnotations] GET: /flora-malesiana/taxon/065068df-055b-4756-bbca-fbl0adlecafd4f/annot
ations
00:00:05.482 [flora-malesiana] [gtp527446182-27609] INFO e.e.c.r.controller.HttpStatusMessage - H
TTP 404 : uuid not found
00:00:05.482 [flora-malesiana] [gtp527446182-27609] WARN e.e.cdm.servlet.DateHeaderFilter - Can n
ot add data header.
org.springframework.web.util.NestedServletException: Request processing failed; nested exception i
s java.lang.NullPointerException

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:9
81)

at org.springframework.web.servlet.FrameworkServlet.doGet (FrameworkServlet.java:860)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:687)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse. jetty.servlet.ServletHolder$NotAsyncServlet.service (ServletHolder. java:1395

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:755)

at org.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1617)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (Filt
erSecurityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Fi
lterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTr
anslationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManage
mentFilter. java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.AnonymousAuthenticationFilter.doFilter (
AnonymousAuthenticationFilter.java:111)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doF
ilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestC
acheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterI
nternal (BasicAuthenticationFilter.java:158)
at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.ocauth2.provider.authentication.OAuth2AuthenticationProcess
ingFilter.doFilter (OAuth2AuthenticationProcessingFilter.java:176)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilt
er.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWrite
rFilter.java:64)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (Secu
rityContextPersistenceFilter.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter
.doFilterInternal (WebAsyncManagerIntegrationFilter.java:53)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy. jav
a:213)

at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterPro
xy.Jjava:346)

at org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy. jav
a:262)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler. java:1604)

at eu.etaxonomy.cdm.servlet.DateHeaderFilter.doFilter (DateHeaderFilter. java:55)

can be reproduced with requrests like

http://localhost:8080/taxon/6eb85af1-b12b-48ba-8767-a77936261044/specimensOrObservationsCount

Associated revisions

Revision 679982a0 - 05/04/2021 12:56 PM - Andreas Kohlbecker
fix #9185 catching and logging NPE and NestedSevletExecptions properly at appropriate levels

Revision 149¢59a9 - 10/27/2022 11:04 AM - Andreas Miiller
ref #9185 set loglevel to debug for NPE in DateHeaderFilter

History

#1 - 08/12/2020 07:44 AM - Andreas Kohlbecker

can this minor problem be solved by changing the order in DateHeaderFilter.doFilter() like this?

@Override
public void doFilter (ServletRequest request, ServletResponse response, FilterChain chain)
throws IOException, ServletException {

chain.doFilter (request, response);

// add date header at last

OffsetDateTime dateTime = OffsetDateTime.now();

HttpServletResponse httpServletResponse = (HttpServletResponse) response;
httpServletResponse.setHeader ("Date", dateTime.format (DateTimeFormatter .RFC_1123_DATE_TIME)) ;

#2 - 05/04/2021 11:41 AM - Andreas Kohlbecker
http://localhost:8080/taxon/6eb85af1-b12b-48ba-8767-a77936261044/specimensOrObservationsCount

- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 5.25

This error makes cdm-server log hardly readable, hence, it should be solved rather soon.

#3 - 05/04/2021 11:58 AM - Andreas Kohlbecker

- Description updated

#4 - 05/04/2021 12:56 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|679982a065408133{36b72f39d2{70d4fe2856fa.

#5 - 05/04/2021 12:56 PM - Andreas Kohlbecker

review: scan logs

#6 - 05/11/2021 05:47 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed

- % Done changed from 50 to 100

no longer such NPEs in the logs

#7 - 05/17/2021 09:52 AM - Andreas Miiller

- Target version changed from Release 5.25 to Release 5.23
